#include <iostream>
#include "SFML/Graphics.hpp"
#include "SFML/Audio.hpp"

int main()
{
    sf::RenderWindow window( sf::VideoMode( 1024, 600 ), "SFML WORK!" );
    auto loopCounter = 0u;
    bool pauseFlag = false;

    sf::View view(sf::FloatRect(0,0,900,450));

    // view.setCenter(sf::Vector2f(300,300));

    window.setView(view);

    sf::Vector2f spriteSize= {108.0f,140.0};

    sf::Sprite background;
    sf::Texture texture;
    texture.loadFromFile("Monumentvalley3.png");
    background.setTexture(texture);

    // Create sprite
    sf::Texture spriteTexture;

    spriteTexture.loadFromFile("sprite_sheet_transparent.png");
    sf::IntRect locationInTexture;
    locationInTexture.height = static_cast<int>(spriteSize.y);
    locationInTexture.width = static_cast<int>(spriteSize.x);
    unsigned horizontalTextureOffset = 0;
    unsigned verticalTextureOffset = 0 ;
    ++verticalTextureOffset %= 2;
    locationInTexture.left = horizontalTextureOffset * spriteSize.x;
    locationInTexture.top = 0;

    sf::Sprite sprite(spriteTexture);
    //sprite.setPosition(spritePosition);
    sprite.setTextureRect(locationInTexture);
    sprite.setOrigin(sprite.getLocalBounds().width/2.0f,sprite.getLocalBounds().height / 2.0f);
    sprite.setTexture(spriteTexture);
    sprite.setScale(0.5f,0.5f);

    // Music
    sf::Music music;
    music.openFromFile("AgainstTheWind.ogg");
    music.setVolume(40);
    music.play();

    while ( window.isOpen( ) )
    {
        sf::Event event;

        while ( window.pollEvent( event ) )
        {
            switch ( event.type )
            {
            case sf::Event::Closed:
                window.close();
                break;
            case sf::Event::KeyPressed:
                if (sf::Keyboard::isKeyPressed(sf::Keyboard::Q))
                    window.close();
                else if (sf::Keyboard::isKeyPressed(sf::Keyboard::Escape))  // pause
                    pauseFlag = !pauseFlag;
                else if (sf::Keyboard::isKeyPressed(sf::Keyboard::Right))
                {
                    view.move(sf::Vector2f(50.0f,0.0f));
                    std::cout << view.getCenter().x << ' ' << view.getCenter().y << std::endl;
                    if (view.getCenter().x >= 4050.0f)
                        view.setCenter(sf::Vector2f(450,225));
                }
                else {}
                window.setView(view);

            default:
                ;

            }
        }
        if (!pauseFlag)
        {
            loopCounter++;
            if (view.getCenter().x >= 4050.0f)
                    view.setCenter(sf::Vector2f(450,225));
            if (loopCounter%50 == 0)
            {
             //   view.move(sf::Vector2f(10.0f,0));
                view.move(sf::Vector2f(3.0f,0));

                sprite.setPosition(sf::Vector2f(view.getCenter().x,view.getCenter().y+100));

                // Set the texture offset in the sprite sheet
                if (loopCounter%400 == 0)
                    horizontalTextureOffset = 0;
                else
                    horizontalTextureOffset++;

                locationInTexture.left = horizontalTextureOffset * spriteSize.x;
                sprite.setTextureRect(locationInTexture);
                sprite.setTexture(spriteTexture);

                window.setView(view);
            }

        }
        window.clear( );
        window.draw(background);
        window.draw(sprite);

        window.display( );
    }
}
